.386
.model flat, STDCALL
option casemap:none

include \masm32\include\windows.inc

include \masm32\include\kernel32.inc
includelib \masm32\lib\kernel32.lib
include \masm32\include\user32.inc
includelib \masm32\lib\user32.lib

Console80x25 PROTO
DisplayAt    PROTO x:DWORD, y:DWORD, StringBuffer:DWORD, len:DWORD

.data?
 wHnd        HANDLE ?
 rHnd        HANDLE ?
 inpbyte     DWORD ?
 
.data
 ConTitle    db "Win32 Console 80 x 25 Fixed Size", 0
 DispStr     db "Let's do something",10,13
.code
start:

    invoke AllocConsole

    invoke Console80x25

    invoke SetConsoleTextAttribute, wHnd, (BACKGROUND_BLUE OR  FOREGROUND_BLUE OR FOREGROUND_GREEN)
    
    invoke DisplayAt, 32, 12, ADDR DispStr, SIZEOF DispStr

    invoke ReadConsole, rHnd, ADDR inpbyte, 1, NULL, NULL

    invoke ExitProcess, 0

    ret
    

Console80x25 PROC

    LOCAL windowSize:SMALL_RECT
    LOCAL bufferSize:COORD

    mov windowSize.Left, 0
    mov windowSize.Right, 0
    mov windowSize.Top, 79
    mov windowSize.Bottom, 24
    

    mov bufferSize.x, 80
    mov bufferSize.y, 25
    
    invoke GetStdHandle, STD_OUTPUT_HANDLE
    mov wHnd,eax
    
    invoke GetStdHandle, STD_INPUT_HANDLE
    mov rHnd,eax
    
    invoke SetConsoleTitle, ADDR ConTitle
   
    invoke SetConsoleWindowInfo, wHnd, TRUE, ADDR windowSize

    invoke SetConsoleScreenBufferSize, wHnd, DWORD PTR bufferSize

    ret

Console80x25 ENDP

DisplayAt PROC x:DWORD, y:DWORD, StringBuffer:DWORD, len:DWORD
    
    LOCAL n_of_chars:DWORD
    LOCAL position:COORD
    
    mov eax, x
    mov position.x, ax
    mov eax, y
    mov position.y, ax
    
    invoke SetConsoleCursorPosition, wHnd, DWORD PTR position
    invoke WriteConsole, wHnd, StringBuffer, len, ADDR n_of_chars, NULL
    
    ret
DisplayAt ENDP

end start
OPT_Res	0
OPT_DebugL	/Subsystem:CONSOLE /merge:.text=.data /align:512
OPT_Linker	polink
OPT_tmp2asm	1

